<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: plugins/logic/logic.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: plugins/logic/logic.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
*
* @requires json5
* @requires plugin
* @requires events
* @requires functions
*
* @module logic
*/

const plugin = require('../plugin.js')
var schema = require('./schema.json')
const events = require('events')
const JSON5 = require('json5')
const functions = require('./functions.js')

class Logic extends plugin.Plugin {
  constructor() {
    super(schema)
    this.name = "logic"
    this.listener = []
    this.event = new events.EventEmitter()
  }
  
  /**
  * install change stream listeners for all custom collections and the session collection
  */
  setup(config) {
    super.setup(config)
    
    this.runtime_collections = []
    if(this.hasOwnProperty("custom_collections")) {
      if(this.custom_collections) {
        this.runtime_collections = this.custom_collections.slice()
      }
    }
    this.runtime_collections.push("sessions")
    
    for(let collection of this.runtime_collections) {
      if(!this.db.hasOwnProperty(collection)) {
        log.error(this.name, collection + " not found")
        break
      }
      let stream = this.db[collection].changes({ fullDocument: 'updateLookup' })
      
      let change_listener = (change) => {
        if(change.operationType != 'delete' &amp;&amp; change.operationType != 'invalidate')
        {
          if(change.operationType == 'update') {
            this.event.emit("change", {document:change.fullDocument, updated:change.updateDescription.updatedFields, removed:change.updateDescription.removedFields, collection:this.db[collection]})
            //log.debug(this.name, change.updateDescription.updatedFields, change.updateDescription.removedFields)
          } else {
            this.event.emit("change", {document:change.fullDocument, collection:this.db[collection]})
          }
        }
      }
      
      stream.on("change", change_listener)
    }
    
    return schema
  }
  
  /**
  * listen:  
  * returns next cue if there is an instant match.
  * Else it installs listener and returns cancel function.
  *
  * switch:
  * if there is a match or else, next cue is returned to session
  *
  * @returns {Promise} might return a next cue string (switch) or a cancel function (listen)
  */
  cue(data, session) {
    return new Promise((resolve, reject) => {
      for(let item in data) {
        switch(item) {
          case "listen":
            let listener = new Listener(data[item], session, this.event, this.db)
            listener.review()
            .then(result => {
              if(result) {
                listener.cancel()
                return resolve(result)
              }
              return resolve(listener.cancel.bind(listener))
            })
            .catch(error => {
              return reject(error)
            })
            break
          case "switch":
            this.switch(data[item], session)
            .then(result => {
              return resolve(result)
            })
            .catch(error => {
              return reject(error)
            })
            break
          case "function":
            if(typeof functions[data.function.name] === "function") {
              log.info(this.name, "call function " + data.function.name + " with args " + data.function.arguments)
              Object.assign(session, {game_event:this.event, db:this.db})
              functions[data.function.name](data.function.arguments, session)
              .then(result => {
                if(data.function.hasOwnProperty("next")) {
                  if(data.function.next) {
                    return resolve(data.function.next)
                  }
                }
                return resolve(undefined)
              })
              .catch(error => {
                //log.error(this.name, error)
                return reject(error)
              })
            } else {
              //log.error(this.name, data.function.name + " is not a valid function")
              return reject(data.function.name + " is not a valid function")
            }
            break
        }
      }
    })
    
  }
  
  /**
  * dispatches next based on condition. If there is more then one condition matching
  * only the promise resolved with lowest index is returned for the session to dispatch it
  *
  * @returns {Promise} string defining next cue or undefined if none of the conditions matched and no else was defined
  */
  switch(props, session) {
    return new Promise((resolve, reject) => {
      if(props.hasOwnProperty("if")) {
        let condition_promises = []
        for(let if_condition of props["if"]) {
            let condition = new Condition(if_condition, session.variables, this.db)
            condition_promises.push(condition.match())
        }
        Promise.all(condition_promises)
        .then(result => {
          for(let match of result) {
            if(match) {
              return resolve(match)
            }
          }
          if (props.hasOwnProperty("else")) {
            if(props.else.hasOwnProperty("next")) {
              return resolve(props.else.next)
            } else {
              log.warn(this.name, "else is missing a 'next' property")
            }
          } else {
            log.debug(this.name, "no match and no else was defined")
          }
          return resolve(undefined)
        })
        .catch(error => {
          return reject(error)
        })
      }
    })
  }
}

/**
* check differnt types of conditions and dispatch next on a match
*/
class Condition {
  constructor(properties, variables, db) {
    //Object.assign(this, props)
    this.variables = variables
    this.value = properties["value"]
    this.next = properties["next"]
    this.db = db
    
    if(properties.hasOwnProperty("equals")) {
      this.condition = properties.equals
      this.survey = this.equals
      this.name = "equals"
    } else if(properties.hasOwnProperty("lessThan")) {
      this.condition = properties.lessThan
      this.survey = this.lessThan
      this.name = "less than"
    } else if(properties.hasOwnProperty("greaterThan")) {
      this.condition = properties.greaterThan
      this.survey = this.greaterThan
      this.name = "greater than"
    } else if(properties.hasOwnProperty("contains")) {
      this.condition = properties.contains
      this.survey = this.contains
      this.name = "contains"
    } else if(properties.hasOwnProperty("regex")) {
      this.condition = properties.regex
      this.survey = this.regex
      this.name = "regex"
    } else if (properties.hasOwnProperty("find")) {
      this.condition = properties.find
      this.survey = this.query
      this.name = "query"
    }
  }
  
  /**
  * trigger next cue based on match in one of:
  * - equals
  * - contains
  * - regex
  * - query
  *
  * @param {Object} data - properties that resolve that would return match under certain conditions
  * @param {Object} variables - cue context instance of session Variables Object
  *
  * @returns {Promise} returns a string defining the next cue that condition wants to dipatch or undefined it there is no match
  */
  match() {
    return new Promise((resolve, reject) => {
      this.evaluate()
      .then(result => {
        if(result.value != undefined || this.name == "query") {
          if(Array.isArray(result.condition)) {
            if(result.condition) {
              log.debug(this.name, "compare condition '" + result.condition.join(',').substring(0, 30) + "'... with value '" + result.value + "'")
            }
          } else if (typeof result.condition === "string") {
            log.debug(this.name, "compare condition '" + result.condition.substring(0, 30) + "' with value '" + result.value + "'")
          } else {
            log.debug(this.name, "compare condition '" + JSON.stringify(result.condition) + "' with value '" + result.value + "'")
          }
          
          return this.survey(result.value, result.condition)
        } else {
          return undefined
        }
      })
      .then(result => {
        if(result) {
          if(this.hasOwnProperty("next")) {
            this.variables.store({match:result})
            return resolve(this.next)
          } else {
            log.warn(this.name, "no next property defined")
          }
        }
        return resolve(undefined)
      })
      .catch(error => {
        log.error(this.name, error)
        return reject(error)
      })
    })
  }
  
  /**
  * review value / condition pair to replace variables if any
  *
  * @returns {Promise} condition and value property with replaced variables if any
  */
  evaluate() {
    return new Promise((resolve, reject) => {
      if(this.value) {
        this.variables.review(this.value)
        .then(result => {
          if(typeof result === "string" || typeof result === "undefined"){
            this.value = result
          } else if (typeof result.toString === "function") {
            this.value = result.toString()
          }
          
          if(this.name == "query") {
            return this.variables.findAndReplace(this.condition)
          } else {
            return this.variables.review(this.condition)
          }
        })
        .then(result => {
          this.condition = result
          return resolve({condition:this.condition, value:this.value})
        })
        .catch(error => {
          log.error(this.name, error)
        })
      } else {
        let promise
        if(this.name == "query") {
          promise = this.variables.findAndReplace(this.condition)
        } else {
          promise = this.variables.review(this.condition)
        }
        
        promise
        .then(result => {
          this.condition = result
          return resolve({condition:this.condition})
        })
        .catch(error => {
          log.error(this.name, error)
        })
      }
      
    })
  }
  
  /**
  * check value against condition
  * if value matches condition exactly or  
  * if condition is empty string or  
  * if one item in condition array matches value exactly, return value
  *
  * else return undefined
  *
  * @returns {Promise} the value if it matched the condition or undefined
  */
  equals(value, condition) {
    return new Promise((resolve, reject) => {
      if(typeof condition === "string") {
        if(value.toUpperCase() == condition.toUpperCase() || condition == "") {
          return resolve(value)
        }
      } else if(Array.isArray(condition)) {
        let upper = condition.forEach(cond => cond.toUpperCase())
        if(upper.includes(value.toUpperCase())) {
          return resolve(value)
        }
      } else {
        log.warn(this.name, "can not resolve condition because condition type is neither string nor array")
      }
      return resolve(undefined)
    })
  }
  
  /**
  * check value against condition
  * if value is Number and less then condition return value
  */
  lessThan(value, condition) {
    return new Promise((resolve, reject) => {
      if(!isNaN(value)) {
        if(!isNaN(condition)) {
          if(condition == "") {
            log.warn(this.name, "empty condition string")
            return resolve(undefined)
          } else if(value == "") {
            log.warn(this.name, "empty value string")
            return resolve(undefined)
          }
          if(Number(value) &lt; Number(condition)) {
            return resolve(value)
          }
        } else if(Array.isArray(condition)) {
          for(let cond of condition) {
            if(!isNaN(cond)) {
              if(condition == "") {
                log.warn(this.name, "contains empty condition string")
              } else if(value == "") {
                log.warn(this.name, "contains empty value string")
              } else if(Number(value) &lt; Number(condition)) {
                return resolve(value)
              }
            } else {
              log.warn(this.name, cond + " is not a Number")
            }
          }
        } else {
          log.warn(this.name, "can not resolve because condition " + condition +" is neither Number nor Array")
          return resolve(undefined)
        }
      } else {
        log.warn(this.name, "can not resolve because value " + value + " is neither Number nor Array")
        return resolve(undefined)
      }
      return resolve(undefined)
    })
  }
  
  /**
  * check value against condition
  * if value is Number and geater then condition return value
  */
  greaterThan(value, condition) {
    return new Promise((resolve, reject) => {
      if(!isNaN(value)) {
        if(!isNaN(condition)) {
          if(condition == "") {
            log.warn(this.name, "empty condition string")
            return resolve(undefined)
          } else if(value == "") {
            log.warn(this.name, "empty value string")
            return resolve(undefined)
          }
          if(Number(value) > Number(condition)) {
            return resolve(value)
          }
        } else if(Array.isArray(condition)) {
          for(let cond of condition) {
            if(!isNaN(cond)) {
              if(condition == "") {
                log.warn(this.name, "contains empty condition string")
              } else if(value == "") {
                log.warn(this.name, "contains empty value string")
              } else if(Number(value) > Number(condition)) {
                return resolve(value)
              }
            } else {
              log.warn(this.name, cond + " is not a Number")
            }
          }
        } else {
          log.warn(this.name, "can not resolve because condition " + condition +" is neither Number nor Array")
          return resolve(undefined)
        }
      } else {
        log.warn(this.name, "can not resolve because value " + value + " is neither Number nor Array")
        return resolve(undefined)
      }
      return resolve(undefined)
    })
  }
  
  /**
  * check value against condition
  * if condition is contained in value or  
  * if condition is empty string or  
  * if one item in condition array is contained in value return condition that matched the value
  *
  * else return undefined
  *
  * @returns {Promise} condition that matched the value or undefined
  */
  contains(value, condition) {
    return new Promise((resolve, reject) => {
      if(typeof condition === "string") {
        if(value.toUpperCase().indexOf(condition.toUpperCase()) >= 0) {
          if(condition == '') {
            return resolve(value)
          }
          return resolve(condition)
        }
      } else if(Array.isArray(condition)) {
        for(let cond of condition) {
          if(value.toUpperCase().indexOf(cond.toUpperCase()) >= 0) {
            return resolve(cond)
          }
        }
      } else {
        log.warn(this.name, "can not resolve condition because condition type is neither string nor array")
      }
      return resolve(undefined)
    })
  }
  
  /**
  * check value against regex
  * if regex matches, resolve with first match
  * if condition is an array, it itreates over all conditions and resolves if/once any of them matches
  *
  * regex is case insensitive (i) and returns after first match (not g / global)
  * 
  * @returns {Promise} part of value that was matching the regex. If none did, undefined
  */
  regex(value, condition) {
    return new Promise((resolve, reject) => {
      if(typeof condition === "string") {
        let res = value.match(new RegExp(condition, "i"))
        if(res) {
          return resolve(res[0])
        }
      } else if(Array.isArray(condition)) {
        for(let cond of condition) {
          let res = value.match(new RegExp(cond, "i"))
          if(res) {
            return resolve(res[0])
          }
        }
      } else {
        log.warn(this.name, "can not resolve condition because condition type is neither string nor array")
      }
      return resolve(undefined)
    })
  }
  
  /**
  * if path and value are defined, true is returned if values are equal.
  * without path and value, true is returned if query returns any document in collection
  *
  * @param {String} condition.collection - what collecton to search in
  * @param {Object} condition.query - mongo find query.
  * @param {String} condition.path - '.' noted path to address distinct property in document returned by query
  * @param {String} value - if condition contains path, compare value with what is in document at path
  */
  query(value, condition) {
    return new Promise((resolve, reject) => {
      if(!this.db.hasOwnProperty(condition.collection)) {
        return reject("Collection " + condition.collection + " not found.")
      }
      
      if(!condition.hasOwnProperty("query")) {
        return reject("Query property missing.")
      }
      
      let find_query = condition.query
      
      if(typeof(condition.query) === "string") {
        if(condition.query[0] == '{') {
          try {
            find_query = JSON5.parse(condition.query)
          } catch(err) {
            if(err instanceof SyntaxError) {
              return reject('syntax error in query "' + condition.query + '"')
            } else {
              log.error(this.name, 'Error when parsing to json:')
              return reject(err)
            }
          }
        } else {
          return reject("Invalid query: " + condition.query)
        }
      }
      
      if(condition.hasOwnProperty("path")) {
        this.db[condition.collection].distinct(condition.path, find_query)
        .then(result => {
          if(!result) {
            return resolve(undefined)
          }
          for(let res of result) {
            log.debug(this.name, "compare " + value + " with " + res)
            if(value == res) {
              return resolve(res[0])
            }
          }
          return resolve(undefined)
        })
        .catch(error => {
          return reject(error)
        })
      } else {
        this.db[condition.collection].find(find_query)
        .then(result => {
          
          if(!result) {
            return resolve(undefined)
          }
          log.debug(this.name, "trigger if " + JSON.stringify(find_query) + " in collection " + condition.collection + " returns 1 or more Documents")
          
          if(value){
            if(result.length == value) {
              return resolve(result.length)
            } else {
              return resolve(undefined)
            }
          } else {
            if(result.length > 0) {
              return resolve(result.length)
            } else {
              return resolve(undefined)
            }
          }
        })
        .catch(error => {
          return reject(error)
        })
      }
    })
  }
}

/**
* creates listener for changes to custom databse collections.
*
* A match immediatly canceles and deactivates (active=false) the listener.
* it is not unlikely that changes to a collection are made at practically the same moment, 
* so there may be unresolved promises in the pipeline even though the event listener was canceled. 
* Thats why any output after a first match is blocked so there are no multiple next cues.
*/
class Listener {
  constructor(props, session, event, db) {
    Object.assign(this, props)
    this.active = true
    this.callback = session.callback
    this.variables = session.variables
    this.cue = session.cue
    this.db = db
    if(props.hasOwnProperty('next')) {
      if(props.next.split('.').length == 1)
      {
        props.next = session.chapter + '.' + props.next
      }
    }
    
    this.name = session._id + " listener"
    
    //this.query = session.variables.parseQuery(props.on)
    
    this.event = event
    
    this.rev = (change) => {
      this.review(change)
      .then(result => {
        if(result) {
          if(this.active) {
            this.active = false
            this.callback(result)
          } else {
            log.warn(this.name, "tried to dispatch next cue but was already canceled")
          }
        }
      })
      .catch(error => {
        log.error(this.name, error)
      })
    }
    
    this.event.on("change", this.rev)
    
    log.info(this.name, "installed.")
  }
  
  /**
  * run match functions to check the changed collections for listener conditions
  * 
  * begins with: ignore changes if change results from storing a listener match in the current cue
  * listener does not cancel quick enough to ignore this change so it would otherwise trigger twice
  *
  * @todo make a more sophisticated pre check what documents or changes to take into account
  * this might also make the above store ignore obsolete
  */
  review(change) {
    return new Promise((resolve, reject) => {
      
      if(change) {
        if(change.collection.name == "sessions") {
          if(change.hasOwnProperty("updated")) {
            if(change.updated.hasOwnProperty(this.cue)) {
              if(change.updated[this.cue].hasOwnProperty("listen")) {
                //log.info("IGNORE UPDATE", change.updated)
                return resolve(undefined)
              }
            }
          }
        }
      }
      
      if(this.hasOwnProperty("if")) {
        let condition_promises = []
        for(let if_condition of this["if"]) {
            let condition = new Condition(if_condition, this.variables, this.db)
            condition_promises.push(condition.match())
        }
        Promise.all(condition_promises)
        .then(result => {
          for(let match of result) {
            if(match) {
              return resolve(match)
            }
          }
          return resolve(undefined)
        })
        .catch(error => {
          return reject(error)
        })
      }
    })
  }
  
  cancel() {
    this.active = false
    this.event.removeListener("change", this.rev)
    log.debug(this.name, "closed. " + this.event.listenerCount("change") + " listeners left open")
  }
}

module.exports.Plaitool = Logic
//module.exports.setup = logic.setup.bind(logic)
//module.exports.cue = logic.cue.bind(logic)
module.exports.Condition = Condition
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
